#include <fstream>
#include <iostream>
#include <string>
#include <stack>

using std::endl;
using std::cout;
using std::cerr;
using std::cin;
using std::stack;
using std::string;

class cumulative_operation {
public:
    virtual double execute(double value) = 0;
    virtual ~cumulative_operation(){ ; }
};

class pricitac: public cumulative_operation {
};

class nasobic: public cumulative_operation {
};

class odecitac: public cumulative_operation {
};

class increment: public pricitac {
public:
    virtual double execute(double value){ return value + 1; }
};

class adder: public pricitac {
public:
    adder(double value = 0):m_val(value){ ; }
    virtual double execute(double value){ return m_val + value; }  

private:
    double m_val;
};

class square: public nasobic {
public:
    virtual double execute(double value){ return value * value; }
};

class decrement: public odecitac {
    virtual double execute(double value){ return value - 1; }
};

int main(){
    double argument;
    
    cout << "Zadejte cislo pro ktere se provedou operace increment(square(decrement(adder6(cislo)))): ";
    cin >> argument;

    typedef stack<cumulative_operation *> operations_stack;
    operations_stack operations;
    operations.push(new increment);
    operations.push(new square);
    operations.push(new decrement);
    operations.push(new adder(6));

    while (!operations.empty()){
        cumulative_operation * current = operations.top();
        operations.pop();

        if (current == NULL){ continue; }

        argument = current->execute(argument);
        delete current;
        current = 0;
    }

    cout << "Vysledek je: " << argument << endl;

    return 0;
}






